<template>
  <div>
    <h1>Connexion</h1>
    <form @submit.prevent="login">
      <label for="email">Email</label>
      <input id="email" v-model="email" type="email" />
      <label for="password">Mot de passe</label>
      <input id="password" v-model="password" type="password" />
      <input type="submit" value="Se connecter" />
    </form>
  </div>
</template>

<script>
import gql from 'graphql-tag'
export default {
  data() {
    return {
      email: '',
      password: '',
    }
  },
  methods: {
    login() {
      if (this.email && this.password) {
        this.$apollo
          .mutate({
            mutation: gql`
              mutation($email: String!, $password: String!) {
                login(data: { email: $email, password: $password }) {
                  token
                  user {
                    name
                    email
                  }
                }
              }
            `,
            variables: {
              email: this.email,
              password: this.password,
            },
          })
          .then(({ data }) => {
            if (data.login.token) {
              // Stocker le token
              this.$apolloHelpers.onLogin(data.login.token)

              // Stocker les infos de l'utilisateur dans le store pour un accès global
              this.$store.commit('updateUser', data.login.user)

              // Redirection
              this.$router.push('/new-post')
            }
          })
      }
    },
  },
}
</script>

<style lang="scss" scoped></style>
